﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Com.Piwigo.Lib.Service;

namespace Com.Piwigo.Lib.IService
{
    public sealed class PwgServiceProvider
        {
            static readonly PwgServiceProviderBase _instance = new PwgServiceProviderBase();

            // Explicit static constructor to tell C# compiler
            // not to mark type as beforefieldinit
            static PwgServiceProvider()
            {
            }

            public static PwgServiceProviderBase Instance
            {
                get
                {
                    return _instance;
                }
            }

            public class PwgServiceProviderBase
            {
                private IPwgAlbumsService _pwgAlbumsService;
                public IPwgAlbumsService PwgAlbumsService
                {
                    get
                    {
                        if (_pwgAlbumsService == null)
                        {
                            _pwgAlbumsService = new PwgAlbumsService();
                        }
                        return _pwgAlbumsService;
                    }
                }

                private IPwgSessionService _pwgSessionService;
                public IPwgSessionService PwgSessionService
                {
                    get
                    {
                        if (_pwgSessionService == null)
                        {
                            _pwgSessionService = new PwgSessionService();
                        }
                        return _pwgSessionService;
                    }
                }


                private IPwgTagsService _pwgTagsService;
                public IPwgTagsService PwgTagsService
                {
                    get
                    {
                        if (_pwgTagsService == null)
                        {
                            _pwgTagsService = new PwgTagsService();
                        }
                        return _pwgTagsService;
                    }
                }

                private IPwgImagesService _pwgImagesService;
                public IPwgImagesService PwgImagesService
                {
                    get
                    {
                        if (_pwgImagesService == null)
                        {
                            _pwgImagesService = new PwgImagesService();
                        }
                        return _pwgImagesService;
                    }
                }

                private IPwgSetupService _pwgSetupService;
                public IPwgSetupService PwgSetupService
                {
                    get
                    {
                        if (_pwgSetupService == null)
                        {
                            _pwgSetupService = new PwgSetupService();
                        }
                        return _pwgSetupService;
                    }
                }
            }
        
        }
}
