﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using Com.Piwigo.Lib.DTO;

namespace Com.Piwigo.Lib.Proxy.Response
{
    [Serializable()]
    [XmlRoot(ElementName = "rsp")]
    public class PwgAddSimpleImageProxyResponse : PwgBaseProxyReponse
    {
        [XmlElement("image_id")]
        public Int32 Id { get; set; }
        [XmlElement("url")]
        public String UrlImage { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "rsp")]
    public class PwgImageRateProxyResponse : PwgBaseProxyReponse
    {
        [XmlElement("count")]
        public Int32 Count { get; set; }
        [XmlElement("average")]
        public String Average { get; set; }
        [XmlElement("stdev")]
        public String Stdev { get; set; }
    }
     

    [Serializable()]
    [XmlRoot(ElementName = "category")]
    public class PwgImageProxyResponse 
    {
        [XmlAttribute(AttributeName = "id")]
        public Int32 Id { get; set; }
        [XmlAttribute(AttributeName = "width")]
        public Int32 Width { get; set; }
        [XmlAttribute(AttributeName = "height")]
        public Int32 Height { get; set; }
        [XmlAttribute(AttributeName = "file")]
        public String File { get; set; }
        [XmlAttribute(AttributeName = "tn_url")]
        public String UrlThunb { get; set; }
        [XmlAttribute(AttributeName = "element_url")]
        public String UrlElement { get; set; }
        [XmlAttribute(AttributeName = "high_url")]
        public String UrlHighDef { get; set; }
        [XmlAttribute(AttributeName = "hit")]
        public Int64 Counter { get; set; }
        [XmlAttribute(AttributeName = "date_creation")]
        public String CreatingDate { get; set; }
        [XmlAttribute(AttributeName = "date_available")]
        public String AvailableDate { get; set; }

        [XmlArray("tags")]
        [XmlArrayItem("tag")]
        public PwgTagProxyResponse[] Tags { get; set; }

        [XmlArray("categories")]
        [XmlArrayItem("category")]
        public PwgAlbumProxyResponse[] Albums { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "rsp")]
    public class PwgImageInfoProxyResponse : PwgBaseProxyReponse
    {
        [XmlElement("image")]
        public PwgImageInfoImageProxyResponse ImageInfo { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "image")]
    public class PwgImageInfoImageProxyResponse : PwgImageProxyResponse
    {
        public String ExtThumbail { get; set; }
        [XmlAttribute(AttributeName = "author")]
        public String Author { get; set; }
        [XmlAttribute(AttributeName = "filesize")]
        public Int64 ImageFileSize { get; set; }
        [XmlAttribute(AttributeName = "date_metadata_update")]
        public String DateUpdateMetaData { get; set; }
        [XmlAttribute(AttributeName = "has_high")]
        public Boolean hasHighDef { get; set; }
        [XmlAttribute(AttributeName = "high_filesize")]
        public Int64 HighDefFileSize { get; set; }
        [XmlAttribute(AttributeName = "level")]
        public Int32 ConfidentialLevel { get; set; }
        [XmlAttribute(AttributeName = "md5sum")]
        public String md5Sum { get; set; }
        [XmlAttribute(AttributeName = "added_by")]
        public Int32 UserIdAddedBy { get; set; }

        [XmlElement("name")]
        public String Name { get; set; }

        [XmlElement("rates")]
        public PwgImageRateProxyResponse ImageRate { get; set; }
        
        [XmlElement("comments")]
        public PwgCommentPageProxyResponse ImageComments { get; set; }

        [XmlElement("comment_post")]
        public PwgPostCommentSecurityInfo PostCommentSecurityData { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "comment_post")]
    public class PwgPostCommentSecurityInfoProxyResponse
    {
        [XmlAttribute(AttributeName = "author")]
        public String Author { get; set; }
        [XmlAttribute(AttributeName = "key")]
        public String AllowPostKey { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "comments")]
    public class PwgCommentPageProxyResponse
    {
        [XmlAttribute("page")]
        public Int32 Page { get; set; }
        [XmlAttribute("per_page")]
        public Int32 PerPage { get; set; }
        [XmlAttribute("count")]
        public Int32 CountOf { get; set; }
        [XmlAttribute("nb_comments")]
        public Int32 TotalCommentNumber { get; set; }

        [XmlElement("comment", typeof(PwgCommentProxyResponse))]
        public PwgCommentProxyResponse[] Comments { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "comments")]
    public class PwgCommentProxyResponse
    {
        [XmlAttribute("id")]
        public Int32 Id { get; set; }
        [XmlAttribute("date")]
        public DateTime CommentDate { get; set; }
        [XmlAttribute("author")]
        public String Author { get; set; }
        [XmlAttribute("content")]
        public String Content { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "images")]
    public class PwgImageListProxyResponse
    {
        [XmlAttribute("page")]
        public Int32 Page { get; set; }
        [XmlAttribute("per_page")]
        public Int32 PerPage { get; set; }
        [XmlAttribute("count")]
        public Int32 Count { get; set; }

        [XmlElement("image", typeof(PwgImageProxyResponse))]
        public PwgImageProxyResponse[] Images { get; set; }


    }

    [Serializable()]
    [XmlRoot(ElementName = "rsp")]
    public class PwgImagesProxyResponse : PwgBaseProxyReponse
    {
        [XmlElement("images")]
        public PwgImageListProxyResponse ImageList { get; set; }
    }

}
