﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Com.Piwigo.Uploader.DTO;

namespace Com.Piwigo.Uploader.Service
{
    public class LoadFromDirectory : IService 
    {
        string[] extensions = { ".jpeg", ".jpg" };

        private LocalAlbum loadDirectory(String dirName, Int32? rootAlbumId)
        {
            DirectoryInfo dir = new DirectoryInfo(dirName); 
            LocalAlbum album = new LocalAlbum (){ LocalDir=dir.FullName, Name=dir.Name};
            album.MessageInfo = "";
            album.UpperCatId = rootAlbumId;
            
            // loading image data in album
            album.LocalImages = new LocalImageList();
            foreach (string strfile in Directory.EnumerateFiles(dir.FullName, "*.*", SearchOption.TopDirectoryOnly)
                .Where(s => extensions.Any(ext => ext == Path.GetExtension(s))))
            {
                FileInfo fi = new  FileInfo(strfile);
                LocalImage img = new LocalImage();
                img.LocalFile = fi.FullName;
                img.Name = fi.Name;
                img.Author = "";
                img.AuthorComment = "";
                album.LocalImages.Add(img);
            }

            album.SubAlbums = new LocalAlbumList();
            foreach (string strdir in Directory.EnumerateDirectories(dir.FullName))
            {
                album.SubAlbums.Add(loadDirectory(strdir, null));
            }

            return album;
        }

        public void runService()
        {
            ModelManager.Instance.lstAlbumLocaux.Add(
                loadDirectory(ModelManager.Instance.directoryName,
                null)
                );
        }
    }
}
