﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Com.Piwigo.Uploader.DTO;
using Com.Piwigo.Lib.DTO;
using Com.Piwigo.Lib.IService;

namespace Com.Piwigo.Uploader.Service
{
    public class UploadToPiwigo : IService 
    {
        public void runService()
        {
            foreach (LocalAlbum Alb in ModelManager.Instance.lstAlbumLocaux)
            {
                uploadAlbum(Alb, ModelManager.Instance.PwgAlbumIdSelected);
            } 
        }

        internal void uploadAlbum(LocalAlbum aAlbum, Int32? catId)
        {
            Boolean rc;
            Int32 IdNewAlbum = 0;
            String strMsgInfo = String.Empty;
            rc = PwgServiceProvider.Instance.PwgAlbumsService.AddAlbum(aAlbum.Name, catId, ref  IdNewAlbum, ref strMsgInfo);

            if (rc == true)
            {
                aAlbum.Id = IdNewAlbum;

                foreach (LocalImage Img in aAlbum.LocalImages)
                {
                    if (aAlbum.Id.HasValue)
                    {
                        Img.UpperCatId = aAlbum.Id.Value;
                    }
                    uploadImage(Img);
                }

                foreach (LocalAlbum Alb in aAlbum.SubAlbums)
                {
                    uploadAlbum(Alb, null);
                }
            }
            else
            {
                throw new ApplicationException("uploadlabum error");
            }
        }

        internal void uploadImage(LocalImage aImg)
        {
            FileInfo fi = new FileInfo(aImg.LocalFile);

            List<PwgTag> lstTag = new List<PwgTag>(aImg.LstTags);

            PwgServiceProvider.Instance.PwgImagesService.addImageByMultiPartForm(fi, null, aImg.UpperCatId, aImg.Name, aImg.Author, aImg.AuthorComment, aImg.ConfidentialLevel, lstTag);
        }
    }
}
