﻿using System;
using System.Collections.Generic;
using Com.Piwigo.Lib.IService;
using Com.Piwigo.Wpf.DTO;
using Com.Piwigo.Lib.DTO;
using Com.Piwigo.Wpf.DTO.Helper;
using Com.Piwigo.Wpf.Helper;
using Com.Piwigo.Wpf.Service;

namespace Com.Piwigo.Wpf.Command
{
    public sealed class PwgCmdGetSubAlbumforAlbum : AsyncCommand
    {
        public override string Text { get { return "Get sub-Albums for a Album"; } }

        protected override void OnExecute(object parameter)
        {
            PwgAlbumWPF catParam;
            try
            {
                if (parameter is PwgAlbumWPF)
                {
                    PwgImageListWPF lstImgWPF = PwgModelManager.Instance.ImageList;
                    catParam = (PwgAlbumWPF)parameter;

                    SendUiInfo("Retriving Album list from server...");
                    List<PwgAlbum> lstCat = PwgServiceProvider.Instance.PwgAlbumsService.GetListOfAlbum(catParam.Id, null, null);
                    if (catParam.Childrens == null)
                    {
                        catParam.Childrens = new PwgAlbumListWPF();
                    }
                    PwgAlbumListWPF lstCatWPF = catParam.Childrens;

                    PwgAlbumListWPFHelper.ConvertPwgAlbumListToPwgAlbumListWPF(lstCat, ref lstCatWPF);
                    catParam.IsExpanded = true;
                }
            }
            catch (PwgServiceException ex)
            {
                SendUiInfo("Error " + ex.NumeroErr + " " + ex.MessageErr);
            }
        }
    }
}
