﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Com.Piwigo.Lib.DTO;

namespace Com.Piwigo.Wpf.DTO.Helper
{
    public static class PwgImageWPFHelper
    {
        public static void ConvertPwgImageToPwgImageWPF(PwgImage aPwgImage,
                                                       ref PwgImageWPF aPwgImageWPF)
        {
            if (aPwgImage != null)
            {
                if (aPwgImageWPF == null)
                {
                    aPwgImageWPF = new PwgImageWPF();
                }

                aPwgImageWPF.Id = aPwgImage.Id;
                aPwgImageWPF.Counter = aPwgImage.Counter;
                aPwgImageWPF.File = aPwgImage.File;
                aPwgImageWPF.Height = aPwgImage.Height;
                aPwgImageWPF.UrlElement = aPwgImage.UrlElement;
                aPwgImageWPF.UrlHighDef = aPwgImage.UrlHighDef;
                aPwgImageWPF.UrlThunb = aPwgImage.UrlThunb;
                aPwgImageWPF.Width = aPwgImage.Width;

                if (aPwgImageWPF.Albums == null)
                {
                    aPwgImageWPF.Albums = new System.Collections.ObjectModel.ObservableCollection<PwgAlbumWPF>();
                }
                else
                {
                    aPwgImageWPF.Albums.Clear();
                }

                foreach (PwgAlbumWPF c in aPwgImageWPF.Albums)
                {
                    aPwgImageWPF.Albums.Add(c);
                }

                //if (aPwgImageWPF.Tags == null)
                //{
                //    aPwgImageWPF.Tags = new System.Collections.ObjectModel.ObservableCollection<PwgTag>();
                //}
                //else
                //{
                //    aPwgImageWPF.Tags.Clear();
                //}

                //foreach (PwgTag t in aPwgImageWPF.Tags)
                //{
                //    aPwgImageWPF.Tags.Add(t);
                //}

            }

        }
    }
}
