﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using Com.Piwigo.Lib.DTO;

namespace Com.Piwigo.Wpf.DTO
{
    public class LocalPwgImageListWPF : AsyncObservableCollection<LocalPwgImageWPF>
    {}

    public class LocalPwgImageWPF : INotifyPropertyChanged
    {
        //FileInfo highResFile, FileInfo lowResFile, FileInfo thumbFile, String imageName, String imageAuthor, DateTime creationDate,
        //    String authorComment, List<String> lstAlbums, List<String> lstTags, PwgConfidentLevelEnum? confidentLevel

        private Int32 _id;
        public Int32 Id
        {
            set { _id = value; OnPropertyChanged("Id"); }
            get { return _id; }
        }

        private String _authorComment;
        public String AuthorComment
        {
            set { _authorComment = value; OnPropertyChanged("AuthorComment"); }
            get { return _authorComment; }
        }

        private String _name;
        public String Name
        {
            set { _name = value; OnPropertyChanged("Name"); }
            get { return _name; }
        }

        private String _localFile;
        public String LocalFile
        {
            set { _localFile = value; OnPropertyChanged("LocalFile"); }
            get { return _localFile; }
        }

        private Int32 _upperCatId;
        public Int32 UpperCatId
        {
            set { _upperCatId = value; OnPropertyChanged("UpperCatId"); }
            get { return _upperCatId; }
        }

        private AsyncObservableCollection<PwgTagWPF> _lstTags;
        public  AsyncObservableCollection<PwgTagWPF> LstTags
        {
            set { _lstTags = value; OnPropertyChanged("LstTags"); }
            get { return _lstTags; }
        }

        private PwgConfidentLevelEnum _confidentialLevel;
        public PwgConfidentLevelEnum ConfidentialLevel
        {
            set { _confidentialLevel = value; OnPropertyChanged("ConfidentialLevel"); }
            get { return _confidentialLevel; }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(info));
        }


    }
}
